Create a message
Send a task or follow-up message to an existing session, resume work, or steer an active agent turn using deliveryMode.
import Tembo from '@tembo-io/sdk';
const client = new Tembo();
const message = await client.messages.create({
content: 'x',
sessionId: '7c9e6679-7425-40de-944b-e07fc1f90ae7',
});use tembo_rs::*;
let client = Tembo::from_env()?;
let response = client
.messages()
.create(MessagesCreateBody {
artifact_id: None,
content: "x".to_string(),
mcp_servers: None,
pull_request_id: None,
session_id: "7c9e6679-7425-40de-944b-e07fc1f90ae7".to_string(),
agent_options: None,
delivery_mode: None,
rich_content: None,
slash_command: None,
})
.send()
.await?;
curl --request POST \
--url https://api.tembo.io/v1/messages \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"content": "<string>",
"sessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"artifactId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"mcpServers": [
"<string>"
],
"pullRequestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"agentOptions": {
"reasoningLevel": "<string>",
"goal": {
"enabled": true,
"objective": "<string>"
},
"ultracode": true
},
"richContent": {
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [
{
"type": "text",
"text": "Hello"
}
]
}
]
}
}
'import requests
url = "https://api.tembo.io/v1/messages"
payload = {
"content": "<string>",
"sessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"artifactId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"mcpServers": ["<string>"],
"pullRequestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"agentOptions": {
"reasoningLevel": "<string>",
"goal": {
"enabled": True,
"objective": "<string>"
},
"ultracode": True
},
"richContent": {
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [
{
"type": "text",
"text": "Hello"
}
]
}
]
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
content: '<string>',
sessionId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
artifactId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
mcpServers: ['<string>'],
pullRequestId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
agentOptions: {
reasoningLevel: '<string>',
goal: {enabled: true, objective: '<string>'},
ultracode: true
},
richContent: {
type: 'doc',
content: [{type: 'paragraph', content: [{type: 'text', text: 'Hello'}]}]
}
})
};
fetch('https://api.tembo.io/v1/messages', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.tembo.io/v1/messages",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'content' => '<string>',
'sessionId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'artifactId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'mcpServers' => [
'<string>'
],
'pullRequestId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'agentOptions' => [
'reasoningLevel' => '<string>',
'goal' => [
'enabled' => true,
'objective' => '<string>'
],
'ultracode' => true
],
'richContent' => [
'type' => 'doc',
'content' => [
[
'type' => 'paragraph',
'content' => [
[
'type' => 'text',
'text' => 'Hello'
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.tembo.io/v1/messages"
payload := strings.NewReader("{\n \"content\": \"<string>\",\n \"sessionId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"artifactId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"mcpServers\": [\n \"<string>\"\n ],\n \"pullRequestId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"agentOptions\": {\n \"reasoningLevel\": \"<string>\",\n \"goal\": {\n \"enabled\": true,\n \"objective\": \"<string>\"\n },\n \"ultracode\": true\n },\n \"richContent\": {\n \"type\": \"doc\",\n \"content\": [\n {\n \"type\": \"paragraph\",\n \"content\": [\n {\n \"type\": \"text\",\n \"text\": \"Hello\"\n }\n ]\n }\n ]\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.tembo.io/v1/messages")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"content\": \"<string>\",\n \"sessionId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"artifactId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"mcpServers\": [\n \"<string>\"\n ],\n \"pullRequestId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"agentOptions\": {\n \"reasoningLevel\": \"<string>\",\n \"goal\": {\n \"enabled\": true,\n \"objective\": \"<string>\"\n },\n \"ultracode\": true\n },\n \"richContent\": {\n \"type\": \"doc\",\n \"content\": [\n {\n \"type\": \"paragraph\",\n \"content\": [\n {\n \"type\": \"text\",\n \"text\": \"Hello\"\n }\n ]\n }\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.tembo.io/v1/messages")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"content\": \"<string>\",\n \"sessionId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"artifactId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"mcpServers\": [\n \"<string>\"\n ],\n \"pullRequestId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"agentOptions\": {\n \"reasoningLevel\": \"<string>\",\n \"goal\": {\n \"enabled\": true,\n \"objective\": \"<string>\"\n },\n \"ultracode\": true\n },\n \"richContent\": {\n \"type\": \"doc\",\n \"content\": [\n {\n \"type\": \"paragraph\",\n \"content\": [\n {\n \"type\": \"text\",\n \"text\": \"Hello\"\n }\n ]\n }\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"hotPath": {
"activeProviderTurnId": "<string>",
"mode": "started",
"providerSessionId": "<string>",
"queuedTurnId": "<string>",
"transport": "<string>"
},
"job": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"task": "<string>"
},
"message": {
"artifactId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"content": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"createdBy": "<string>",
"externalAvatarUrl": "<string>",
"externalUrl": "<string>",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"parentMessageId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"pullRequestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"role": "user",
"sessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "<string>",
"updatedAt": "2023-11-07T05:31:56Z",
"richContent": {
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [
{
"type": "text",
"text": "Hello"
}
]
}
]
},
"slashCommand": {
"command": "<string>",
"arguments": "<string>"
},
"source": "<string>",
"isQueued": true
},
"session": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"title": "<string>"
}
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Body
Text of the task, follow-up, or steering instruction to send to the session agent.
1 - 1000000Session to receive this message. Use this operation to continue work in an existing session.
Artifact to associate with this message.
MCP server or connection IDs selected for this message.
1001 - 200Pull request to associate with this message.
Agent-specific runtime options for this message, such as reasoning effort.
- Option 1
- Option 2
Show child attributes
Show child attributes
queue adds a follow-up task; steer sends guidance to an active agent turn when supported.
queue, steer Optional rich-text representation of the message. Provide the required text content separately.
- Option 1
- Option 2
- Option 3
- Option 4
- Option 5
- Option 6
- Option 7
- Option 8
Show child attributes
Show child attributes
{
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [{ "type": "text", "text": "Hello" }]
}
]
}
Structured slash command to execute with this message.
Show child attributes
Show child attributes
Was this page helpful?
import Tembo from '@tembo-io/sdk';
const client = new Tembo();
const message = await client.messages.create({
content: 'x',
sessionId: '7c9e6679-7425-40de-944b-e07fc1f90ae7',
});use tembo_rs::*;
let client = Tembo::from_env()?;
let response = client
.messages()
.create(MessagesCreateBody {
artifact_id: None,
content: "x".to_string(),
mcp_servers: None,
pull_request_id: None,
session_id: "7c9e6679-7425-40de-944b-e07fc1f90ae7".to_string(),
agent_options: None,
delivery_mode: None,
rich_content: None,
slash_command: None,
})
.send()
.await?;
curl --request POST \
--url https://api.tembo.io/v1/messages \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"content": "<string>",
"sessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"artifactId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"mcpServers": [
"<string>"
],
"pullRequestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"agentOptions": {
"reasoningLevel": "<string>",
"goal": {
"enabled": true,
"objective": "<string>"
},
"ultracode": true
},
"richContent": {
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [
{
"type": "text",
"text": "Hello"
}
]
}
]
}
}
'import requests
url = "https://api.tembo.io/v1/messages"
payload = {
"content": "<string>",
"sessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"artifactId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"mcpServers": ["<string>"],
"pullRequestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"agentOptions": {
"reasoningLevel": "<string>",
"goal": {
"enabled": True,
"objective": "<string>"
},
"ultracode": True
},
"richContent": {
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [
{
"type": "text",
"text": "Hello"
}
]
}
]
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
content: '<string>',
sessionId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
artifactId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
mcpServers: ['<string>'],
pullRequestId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
agentOptions: {
reasoningLevel: '<string>',
goal: {enabled: true, objective: '<string>'},
ultracode: true
},
richContent: {
type: 'doc',
content: [{type: 'paragraph', content: [{type: 'text', text: 'Hello'}]}]
}
})
};
fetch('https://api.tembo.io/v1/messages', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.tembo.io/v1/messages",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'content' => '<string>',
'sessionId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'artifactId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'mcpServers' => [
'<string>'
],
'pullRequestId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'agentOptions' => [
'reasoningLevel' => '<string>',
'goal' => [
'enabled' => true,
'objective' => '<string>'
],
'ultracode' => true
],
'richContent' => [
'type' => 'doc',
'content' => [
[
'type' => 'paragraph',
'content' => [
[
'type' => 'text',
'text' => 'Hello'
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.tembo.io/v1/messages"
payload := strings.NewReader("{\n \"content\": \"<string>\",\n \"sessionId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"artifactId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"mcpServers\": [\n \"<string>\"\n ],\n \"pullRequestId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"agentOptions\": {\n \"reasoningLevel\": \"<string>\",\n \"goal\": {\n \"enabled\": true,\n \"objective\": \"<string>\"\n },\n \"ultracode\": true\n },\n \"richContent\": {\n \"type\": \"doc\",\n \"content\": [\n {\n \"type\": \"paragraph\",\n \"content\": [\n {\n \"type\": \"text\",\n \"text\": \"Hello\"\n }\n ]\n }\n ]\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.tembo.io/v1/messages")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"content\": \"<string>\",\n \"sessionId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"artifactId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"mcpServers\": [\n \"<string>\"\n ],\n \"pullRequestId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"agentOptions\": {\n \"reasoningLevel\": \"<string>\",\n \"goal\": {\n \"enabled\": true,\n \"objective\": \"<string>\"\n },\n \"ultracode\": true\n },\n \"richContent\": {\n \"type\": \"doc\",\n \"content\": [\n {\n \"type\": \"paragraph\",\n \"content\": [\n {\n \"type\": \"text\",\n \"text\": \"Hello\"\n }\n ]\n }\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.tembo.io/v1/messages")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"content\": \"<string>\",\n \"sessionId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"artifactId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"mcpServers\": [\n \"<string>\"\n ],\n \"pullRequestId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"agentOptions\": {\n \"reasoningLevel\": \"<string>\",\n \"goal\": {\n \"enabled\": true,\n \"objective\": \"<string>\"\n },\n \"ultracode\": true\n },\n \"richContent\": {\n \"type\": \"doc\",\n \"content\": [\n {\n \"type\": \"paragraph\",\n \"content\": [\n {\n \"type\": \"text\",\n \"text\": \"Hello\"\n }\n ]\n }\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"hotPath": {
"activeProviderTurnId": "<string>",
"mode": "started",
"providerSessionId": "<string>",
"queuedTurnId": "<string>",
"transport": "<string>"
},
"job": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"task": "<string>"
},
"message": {
"artifactId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"content": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"createdBy": "<string>",
"externalAvatarUrl": "<string>",
"externalUrl": "<string>",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"parentMessageId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"pullRequestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"role": "user",
"sessionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"type": "<string>",
"updatedAt": "2023-11-07T05:31:56Z",
"richContent": {
"type": "doc",
"content": [
{
"type": "paragraph",
"content": [
{
"type": "text",
"text": "Hello"
}
]
}
]
},
"slashCommand": {
"command": "<string>",
"arguments": "<string>"
},
"source": "<string>",
"isQueued": true
},
"session": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"title": "<string>"
}
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}